/*
 * Copyright
 *   2005 axYus - www.axyus.com
 *   2005 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.tools;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.net.URL;
import javax.swing.JFrame;

/**
 *
 * @author chm
 */
public abstract class AbstractTool {
    
    /**
     * Checks if the Plugin is running in or outside Xemelios.
     * @return true if Xemelios is running in the same JVM.
     */
    public static boolean isInXemelios() {
        boolean ret = true;
        URL url = AbstractTool.class.getClassLoader().getResource("fr/gouv/finances/cp/xemelios/ui/MainWindow.class");
        if(url!=null) {
            // la classe est dans le Class-Path
            // on essaie de la charger sans la referencer
            try {
                Class clazz = Class.forName("fr.gouv.finances.cp.xemelios.ui.MainWindow");
                Field fld = clazz.getDeclaredField("instance");
                if((fld.getModifiers() & Modifier.STATIC) >0) {
                    Object value = fld.get(null);
                    ret = (value!=null);
                }
            } catch(Throwable t) {
                ret = false;
            }
        } else {
            ret = false;
        }
        return ret;
    }
    
    public abstract void setParentWindow(JFrame parentWindow);
    public abstract void run();
}
